Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.validation
Class BindException

    java.lang.Object
      java.lang.Throwable
          java.lang.Exception
              org.springframework.validation.BindException

All Implemented Interfaces:
  java.io.Serializable, BindingResult, Errors

    public class BindException

extends java.lang.Exception
implements BindingResult

Thrown when binding errors are considered fatal. Implements the `BindingResult` interface (and its super-interface `Errors`) to allow for the direct analysis of binding errors.

As of Spring 2.0, this is a special-purpose class. Normally, application code will work with the `BindingResult` interface, or with a `DataBinder` that in turn exposes a BindingResult via `DataBinder.getBindingResult()`.

Author:
  Rod Johnson, Juergen Hoeller, Rob Harrop
See Also:
  `BindingResult`, `DataBinder.getBindingResult()`, `DataBinder.close()`, Serialized Form

Field Summary

Fields inherited from interface org.springframework.validation.BindingResult
`MODEL_KEY_PREFIX`

Fields inherited from interface org.springframework.validation.Errors
`NESTED_PATH_SEPARATOR`

Constructor Summary
`BindException(BindingResult bindingResult)` Create a new BindException instance for a BindingResult.
`BindException(java.lang.Object target, java.lang.String objectName)` Create a new BindException instance for a target bean.

Method Summary
`void` | `addAllErrors(Errors errors)` Add all errors from the given `Errors` instance to this `Errors` instance.
`void` | `addError(ObjectError error)` Add a custom `ObjectError` or `FieldError` to the errors list.
`boolean` | `equals(java.lang.Object other)`
`java.beans.PropertyEditor` | `findEditor(java.lang.String field, java.lang.Class valueType)` Find a custom property editor for the given type and property.
`java.util.List<ObjectError>` | `getAllErrors()` Get all errors, both global and field ones.
`BindingResult` | `getBindingResult()` Return the BindingResult that this BindException wraps.
`int` | `getErrorCount()` Return the total number of errors.
`FieldError` | `getFieldError()` Get the first error associated with a field, if any.
`FieldError` | `getFieldError(java.lang.String field)` Get the first error associated with the given field, if any.
`int` | `getFieldErrorCount()` Return the number of errors associated with a field.
`int` | `getFieldErrorCount(java.lang.String field)` Return the number of errors associated with the given field.
`java.util.List<FieldError>` | `getFieldErrors()` Get all errors associated with a field.
`java.util.List<FieldError>` | `getFieldErrors(java.lang.String field)` Get all errors associated with the given field.
`java.lang.Class<?>` | `getFieldType(java.lang.String field)` Return the type of a given field.
`java.lang.Object` | `getFieldValue(java.lang.String field)` Return the current value of the given field, either the current bean property value or a rejected update from the last binding.
`ObjectError` | `getGlobalError()` Get the first global error, if any.
`int` | `getGlobalErrorCount()` Return the number of global errors.
`java.util.List<ObjectError>` | `getGlobalErrors()` Get all global errors.
`java.lang.String` | `getMessage()` Returns diagnostic information about the errors held in this object.
`java.util.Map<java.lang.String,java.lang.Object>` | `getModel()` Return a model Map for the obtained state, exposing a BindingResult instance as '`MODEL_KEY_PREFIX` + objectName' and the object itself as 'objectName'.
`java.lang.String` | `getNestedPath()` Return the current nested path of this `Errors` object.
`java.lang.String` | `getObjectName()` Return the name of the bound root object.
`PropertyEditorRegistry` | `getPropertyEditorRegistry()` Return the underlying PropertyEditorRegistry.
`java.lang.Object` | `getRawFieldValue(java.lang.String field)` Extract the raw field value for the given field.
`java.lang.String[]` | `getSuppressedFields()` Return the list of fields that were suppressed during the bind process.
`java.lang.Object` | `getTarget()` Return the wrapped target object, which may be a bean, an object with public fields, a Map - depending on the concrete binding strategy.
`boolean` | `hasErrors()` Return if there were any errors.
`boolean` | `hasFieldErrors()` Are there any field errors?
`boolean` | `hasFieldErrors(java.lang.String field)` Are there any errors associated with the given field?
`boolean` | `hasGlobalErrors()` Are there any global errors?
`int` | `hashCode()`
`void` | `popNestedPath()` Pop the former nested path from the nested path stack.
`void` | `pushNestedPath(java.lang.String subPath)` Push the given sub path onto the nested path stack.
`void` | `recordSuppressedField(java.lang.String field)` Mark the specified disallowed field as suppressed.
`void` | `reject(java.lang.String errorCode)` Register a global error for the entire target object, using the given error description.
`void` | `reject(java.lang.String errorCode, java.lang.Object[] errorArgs, java.lang.String defaultMessage)` Register a global error for the entire target object, using the given error description.
`void` | `reject(java.lang.String errorCode, java.lang.String defaultMessage)` Register a global error for the entire target object, using the given error description.
`void` | `rejectValue(java.lang.String field, java.lang.String errorCode)` Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.
`void` | `rejectValue(java.lang.String field, java.lang.String errorCode, java.lang.Object[] errorArgs, java.lang.String defaultMessage)` Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.
`void` | `rejectValue(java.lang.String field, java.lang.String errorCode, java.lang.String defaultMessage)` Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.
`java.lang.String[]` | `resolveMessageCodes(java.lang.String errorCode)` Resolve the given error code into message codes.
`java.lang.String[]` | `resolveMessageCodes(java.lang.String errorCode, java.lang.String field)` Resolve the given error code into message codes for the given field.
`void` | `setNestedPath(java.lang.String nestedPath)` Allow context to be changed so that standard validators can validate subtrees.

Methods inherited from class java.lang.Throwable
`fillInStackTrace, getCause, getLocalizedMessage, getStackTrace, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### BindException

    public BindException(BindingResult bindingResult)

  Create a new BindException instance for a BindingResult.

  Parameters:
    `bindingResult` - the BindingResult instance to wrap

### BindException

    public BindException(java.lang.Object target,
                         java.lang.String objectName)

  Create a new BindException instance for a target bean.

  Parameters:
    `target` - target bean to bind onto
    `objectName` - the name of the target object
  See Also:
    `BeanPropertyBindingResult`

Method Detail

### getBindingResult

    public final BindingResult getBindingResult()

  Return the BindingResult that this BindException wraps. Will typically be a BeanPropertyBindingResult.

  See Also:
    `BeanPropertyBindingResult`

### getObjectName

    public java.lang.String getObjectName()

  Description copied from interface: `Errors`
  Return the name of the bound root object.

  Specified by:
    `getObjectName` in interface `Errors`

### setNestedPath

    public void setNestedPath(java.lang.String nestedPath)

  Description copied from interface: `Errors`
  Allow context to be changed so that standard validators can validate subtrees. Reject calls prepend the given path to the field names.

  For example, an address validator could validate the subobject "address" of a customer object.

  Specified by:
    `setNestedPath` in interface `Errors`
  Parameters:
    `nestedPath` - nested path within this object, e.g. "address" (defaults to "", `null` is also acceptable). Can end with a dot: both "address" and "address." are valid.

### getNestedPath

    public java.lang.String getNestedPath()

  Description copied from interface: `Errors`
  Return the current nested path of this `Errors` object.

  Returns a nested path with a dot, i.e. "address.", for easy building of concatenated paths. Default is an empty String.

  Specified by:
    `getNestedPath` in interface `Errors`

### pushNestedPath

    public void pushNestedPath(java.lang.String subPath)

  Description copied from interface: `Errors`
  Push the given sub path onto the nested path stack.

  A `Errors.popNestedPath()` call will reset the original nested path before the corresponding `pushNestedPath(String)` call.

  Using the nested path stack allows to set temporary nested paths for subobjects without having to worry about a temporary path holder.

  For example: current path "spouse.", pushNestedPath("child") -> result path "spouse.child."; popNestedPath() -> "spouse." again.

  Specified by:
    `pushNestedPath` in interface `Errors`
  Parameters:
    `subPath` - the sub path to push onto the nested path stack
  See Also:
    `Errors.popNestedPath()`

### popNestedPath

    public void popNestedPath()
                       throws java.lang.IllegalStateException

  Description copied from interface: `Errors`
  Pop the former nested path from the nested path stack.

  Specified by:
    `popNestedPath` in interface `Errors`
  Throws:
    `java.lang.IllegalStateException` - if there is no former nested path on the stack
  See Also:
    `Errors.pushNestedPath(java.lang.String)`

### reject

    public void reject(java.lang.String errorCode)

  Description copied from interface: `Errors`
  Register a global error for the entire target object, using the given error description.

  Specified by:
    `reject` in interface `Errors`
  Parameters:
    `errorCode` - error code, interpretable as a message key

### reject

    public void reject(java.lang.String errorCode,
                       java.lang.String defaultMessage)

  Description copied from interface: `Errors`
  Register a global error for the entire target object, using the given error description.

  Specified by:
    `reject` in interface `Errors`
  Parameters:
    `errorCode` - error code, interpretable as a message key
    `defaultMessage` - fallback default message

### reject

    public void reject(java.lang.String errorCode,
                       java.lang.Object[] errorArgs,
                       java.lang.String defaultMessage)

  Description copied from interface: `Errors`
  Register a global error for the entire target object, using the given error description.

  Specified by:
    `reject` in interface `Errors`
  Parameters:
    `errorCode` - error code, interpretable as a message key
    `errorArgs` - error arguments, for argument binding via MessageFormat (can be `null`)
    `defaultMessage` - fallback default message

### rejectValue

    public void rejectValue(java.lang.String field,
                            java.lang.String errorCode)

  Description copied from interface: `Errors`
  Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.

  The field name may be `null` or empty String to indicate the current object itself rather than a field of it. This may result in a corresponding field error within the nested object graph or a global error if the current object is the top object.

  Specified by:
    `rejectValue` in interface `Errors`
  Parameters:
    `field` - the field name (may be `null` or empty String)
    `errorCode` - error code, interpretable as a message key
  See Also:
    `Errors.getNestedPath()`

### rejectValue

    public void rejectValue(java.lang.String field,
                            java.lang.String errorCode,
                            java.lang.String defaultMessage)

  Description copied from interface: `Errors`
  Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.

  The field name may be `null` or empty String to indicate the current object itself rather than a field of it. This may result in a corresponding field error within the nested object graph or a global error if the current object is the top object.

  Specified by:
    `rejectValue` in interface `Errors`
  Parameters:
    `field` - the field name (may be `null` or empty String)
    `errorCode` - error code, interpretable as a message key
    `defaultMessage` - fallback default message
  See Also:
    `Errors.getNestedPath()`

### rejectValue

    public void rejectValue(java.lang.String field,
                            java.lang.String errorCode,
                            java.lang.Object[] errorArgs,
                            java.lang.String defaultMessage)

  Description copied from interface: `Errors`
  Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.

  The field name may be `null` or empty String to indicate the current object itself rather than a field of it. This may result in a corresponding field error within the nested object graph or a global error if the current object is the top object.

  Specified by:
    `rejectValue` in interface `Errors`
  Parameters:
    `field` - the field name (may be `null` or empty String)
    `errorCode` - error code, interpretable as a message key
    `errorArgs` - error arguments, for argument binding via MessageFormat (can be `null`)
    `defaultMessage` - fallback default message
  See Also:
    `Errors.getNestedPath()`

### addAllErrors

    public void addAllErrors(Errors errors)

  Description copied from interface: `Errors`
  Add all errors from the given `Errors` instance to this `Errors` instance.

  This is a onvenience method to avoid repeated `reject(..)` calls for merging an `Errors` instance into another `Errors` instance.

  Note that the passed-in `Errors` instance is supposed to refer to the same target object, or at least contain compatible errors that apply to the target object of this `Errors` instance.

  Specified by:
    `addAllErrors` in interface `Errors`
  Parameters:
    `errors` - the `Errors` instance to merge in

### hasErrors

    public boolean hasErrors()

  Description copied from interface: `Errors`
  Return if there were any errors.

  Specified by:
    `hasErrors` in interface `Errors`

### getErrorCount

    public int getErrorCount()

  Description copied from interface: `Errors`
  Return the total number of errors.

  Specified by:
    `getErrorCount` in interface `Errors`

### getAllErrors

    public java.util.List<ObjectError> getAllErrors()

  Description copied from interface: `Errors`
  Get all errors, both global and field ones.

  Specified by:
    `getAllErrors` in interface `Errors`
  Returns:
    List of `ObjectError` instances

### hasGlobalErrors

    public boolean hasGlobalErrors()

  Description copied from interface: `Errors`
  Are there any global errors?

  Specified by:
    `hasGlobalErrors` in interface `Errors`
  Returns:
    `true` if there are any global errors
  See Also:
    `Errors.hasFieldErrors()`

### getGlobalErrorCount

    public int getGlobalErrorCount()

  Description copied from interface: `Errors`
  Return the number of global errors.

  Specified by:
    `getGlobalErrorCount` in interface `Errors`
  Returns:
    the number of global errors
  See Also:
    `Errors.getFieldErrorCount()`

### getGlobalErrors

    public java.util.List<ObjectError> getGlobalErrors()

  Description copied from interface: `Errors`
  Get all global errors.

  Specified by:
    `getGlobalErrors` in interface `Errors`
  Returns:
    List of ObjectError instances

### getGlobalError

    public ObjectError getGlobalError()

  Description copied from interface: `Errors`
  Get the first global error, if any.

  Specified by:
    `getGlobalError` in interface `Errors`
  Returns:
    the global error, or `null`

### hasFieldErrors

    public boolean hasFieldErrors()

  Description copied from interface: `Errors`
  Are there any field errors?

  Specified by:
    `hasFieldErrors` in interface `Errors`
  Returns:
    `true` if there are any errors associated with a field
  See Also:
    `Errors.hasGlobalErrors()`

### getFieldErrorCount

    public int getFieldErrorCount()

  Description copied from interface: `Errors`
  Return the number of errors associated with a field.

  Specified by:
    `getFieldErrorCount` in interface `Errors`
  Returns:
    the number of errors associated with a field
  See Also:
    `Errors.getGlobalErrorCount()`

### getFieldErrors

    public java.util.List<FieldError> getFieldErrors()

  Description copied from interface: `Errors`
  Get all errors associated with a field.

  Specified by:
    `getFieldErrors` in interface `Errors`
  Returns:
    a List of `FieldError` instances

### getFieldError

    public FieldError getFieldError()

  Description copied from interface: `Errors`
  Get the first error associated with a field, if any.

  Specified by:
    `getFieldError` in interface `Errors`
  Returns:
    the field-specific error, or `null`

### hasFieldErrors

    public boolean hasFieldErrors(java.lang.String field)

  Description copied from interface: `Errors`
  Are there any errors associated with the given field?

  Specified by:
    `hasFieldErrors` in interface `Errors`
  Parameters:
    `field` - the field name
  Returns:
    `true` if there were any errors associated with the given field

### getFieldErrorCount

    public int getFieldErrorCount(java.lang.String field)

  Description copied from interface: `Errors`
  Return the number of errors associated with the given field.

  Specified by:
    `getFieldErrorCount` in interface `Errors`
  Parameters:
    `field` - the field name
  Returns:
    the number of errors associated with the given field

### getFieldErrors

    public java.util.List<FieldError> getFieldErrors(java.lang.String field)

  Description copied from interface: `Errors`
  Get all errors associated with the given field.

  Implementations should support not only full field names like "name" but also pattern matches like "na*" or "address.*".

  Specified by:
    `getFieldErrors` in interface `Errors`
  Parameters:
    `field` - the field name
  Returns:
    a List of `FieldError` instances

### getFieldError

    public FieldError getFieldError(java.lang.String field)

  Description copied from interface: `Errors`
  Get the first error associated with the given field, if any.

  Specified by:
    `getFieldError` in interface `Errors`
  Parameters:
    `field` - the field name
  Returns:
    the field-specific error, or `null`

### getFieldValue

    public java.lang.Object getFieldValue(java.lang.String field)

  Description copied from interface: `Errors`
  Return the current value of the given field, either the current bean property value or a rejected update from the last binding.

  Allows for convenient access to user-specified field values, even if there were type mismatches.

  Specified by:
    `getFieldValue` in interface `Errors`
  Parameters:
    `field` - the field name
  Returns:
    the current value of the given field

### getFieldType

    public java.lang.Class<?> getFieldType(java.lang.String field)

  Description copied from interface: `Errors`
  Return the type of a given field.

  Implementations should be able to determine the type even when the field value is `null`, for example from some associated descriptor.

  Specified by:
    `getFieldType` in interface `Errors`
  Parameters:
    `field` - the field name
  Returns:
    the type of the field, or `null` if not determinable

### getTarget

    public java.lang.Object getTarget()

  Description copied from interface: `BindingResult`
  Return the wrapped target object, which may be a bean, an object with public fields, a Map - depending on the concrete binding strategy.

  Specified by:
    `getTarget` in interface `BindingResult`

### getModel

    public java.util.Map<java.lang.String,java.lang.Object> getModel()

  Description copied from interface: `BindingResult`
  Return a model Map for the obtained state, exposing a BindingResult instance as '`MODEL_KEY_PREFIX` + objectName' and the object itself as 'objectName'.

  Note that the Map is constructed every time you're calling this method. Adding things to the map and then re-calling this method will not work.

  The attributes in the model Map returned by this method are usually included in the `ModelAndView` for a form view that uses Spring's `bind` tag in a JSP, which needs access to the BindingResult instance. Spring's pre-built form controllers will do this for you when rendering a form view. When building the ModelAndView instance yourself, you need to include the attributes from the model Map returned by this method.

  Specified by:
    `getModel` in interface `BindingResult`
  See Also:
    `Errors.getObjectName()`, `BindingResult.MODEL_KEY_PREFIX`, `ModelAndView`, `BindTag`, `SimpleFormController`

### getRawFieldValue

    public java.lang.Object getRawFieldValue(java.lang.String field)

  Description copied from interface: `BindingResult`
  Extract the raw field value for the given field. Typically used for comparison purposes.

  Specified by:
    `getRawFieldValue` in interface `BindingResult`
  Parameters:
    `field` - the field to check
  Returns:
    the current value of the field in its raw form, or `null` if not known

### findEditor

    public java.beans.PropertyEditor findEditor(java.lang.String field,
                                                java.lang.Class valueType)

  Description copied from interface: `BindingResult`
  Find a custom property editor for the given type and property.

  Specified by:
    `findEditor` in interface `BindingResult`
  Parameters:
    `field` - the path of the property (name or nested path), or `null` if looking for an editor for all properties of the given type
    `valueType` - the type of the property (can be `null` if a property is given but should be specified in any case for consistency checking)
  Returns:
    the registered editor, or `null` if none

### getPropertyEditorRegistry

    public PropertyEditorRegistry getPropertyEditorRegistry()

  Description copied from interface: `BindingResult`
  Return the underlying PropertyEditorRegistry.

  Specified by:
    `getPropertyEditorRegistry` in interface `BindingResult`
  Returns:
    the PropertyEditorRegistry, or `null` if none available for this BindingResult

### addError

    public void addError(ObjectError error)

  Description copied from interface: `BindingResult`
  Add a custom `ObjectError` or `FieldError` to the errors list.

  Intended to be used by cooperating strategies such as `BindingErrorProcessor`.

  Specified by:
    `addError` in interface `BindingResult`
  See Also:
    `ObjectError`, `FieldError`, `BindingErrorProcessor`

### resolveMessageCodes

    public java.lang.String[] resolveMessageCodes(java.lang.String errorCode)

  Description copied from interface: `BindingResult`
  Resolve the given error code into message codes.

  Calls the configured `MessageCodesResolver` with appropriate parameters.

  Specified by:
    `resolveMessageCodes` in interface `BindingResult`
  Parameters:
    `errorCode` - the error code to resolve into message codes
  Returns:
    the resolved message codes

### resolveMessageCodes

    public java.lang.String[] resolveMessageCodes(java.lang.String errorCode,
                                                  java.lang.String field)

  Description copied from interface: `BindingResult`
  Resolve the given error code into message codes for the given field.

  Calls the configured `MessageCodesResolver` with appropriate parameters.

  Specified by:
    `resolveMessageCodes` in interface `BindingResult`
  Parameters:
    `errorCode` - the error code to resolve into message codes
    `field` - the field to resolve message codes for
  Returns:
    the resolved message codes

### recordSuppressedField

    public void recordSuppressedField(java.lang.String field)

  Description copied from interface: `BindingResult`
  Mark the specified disallowed field as suppressed.

  The data binder invokes this for each field value that was detected to target a disallowed field.

  Specified by:
    `recordSuppressedField` in interface `BindingResult`
  See Also:
    `DataBinder.setAllowedFields(java.lang.String...)`

### getSuppressedFields

    public java.lang.String[] getSuppressedFields()

  Description copied from interface: `BindingResult`
  Return the list of fields that were suppressed during the bind process.

  Can be used to determine whether any field values were targeting disallowed fields.

  Specified by:
    `getSuppressedFields` in interface `BindingResult`
  See Also:
    `DataBinder.setAllowedFields(java.lang.String...)`

### getMessage

    public java.lang.String getMessage()

  Returns diagnostic information about the errors held in this object.

  Overrides:
    `getMessage` in class `java.lang.Throwable`

### equals

    public boolean equals(java.lang.Object other)

  Overrides:
    `equals` in class `java.lang.Object`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `java.lang.Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD